/*

 Copyright  2004, Birger N. Andreasen 
 Please send any bugreports, comments and other issues to:
 E-Mail = bna@post10.tele.dk
 Homepage with other ROTT stuff = http://home14.inet.tele.dk/Bna-Info

*/



//----------------------------------------------------------------------
// Windows Includes...
//----------------------------------------------------------------------
#include <windows.h>
#include "WinRott.h"
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include <dsound.h> 
#include "dxerr.h"
#include "dxerr.c"
#include "resource.h"  // Required for Win32 Resources
#include "develop.h"


#undef RELEASE
#ifdef __cplusplus
#define RELEASE(x) if (x != NULL) {x->Release(); x = NULL;}
#else
#define RELEASE(x) if (x != NULL) {x->lpVtbl->Release(x); x = NULL;}
#endif

//----------------------------------------------------------------------
// Direct Sound and Midi defines 
//----------------------------------------------------------------------

#define SB_SIZE       20480
#define NUM_DSBUFFERS 256

BOOL SetupDirectSound();
void ShutdownDirectSound(void);

LPDIRECTSOUND        lpds;
LPDIRECTSOUNDBUFFER  lpdsbPrimary;
LPDIRECTSOUNDBUFFER  lpdsbuffer[NUM_DSBUFFERS];

typedef enum { 
		midi_nofile, 
		midi_stop, 
		midi_play, 
		midi_pause 
} midi_state;

typedef struct {
    DWORD    MidiPosition;
    DWORD    MidiDevice;
    DWORD    MidiStatus;
    MCIERROR MidiError;
    char     szMidiFile[MAX_PATH];
}MIDI_Data_t;

BOOL  MidiPlay(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiReplay(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiPause(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiResume(HWND hWnd, MIDI_Data_t *mdd);
void  MidiStop(MIDI_Data_t *mdd);
int IsROTTMidiPlaying();
MIDI_Data_t MidiData;
MIDI_Data_t StoreMidiData;

//----------------------------------------------------------------------
// Windows #defines
//----------------------------------------------------------------------
//#define SCREENWIDTH  800
//#define SCREENHEIGHT 600


//----------------------------------------------------------------------
// Windows prototypes
//----------------------------------------------------------------------
extern int main (int argc, char *argv[]);


void    GetWindowsVersion(void);
void	WriteDebug(char *);
void	WriteLBtext(LPSTR txt);
void	ReadDelay(long delay);
int		PlayROTTMidiFile(char *song, boolean loop);
int		StopMidiMusic();
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK About(HWND , UINT , WPARAM , LPARAM );
void	SetRottScreenRes (int Width, int Height);
BOOL	PlayResource(LPSTR lpName) ;
void    ConvertRottParameters(LPSTR WinParameters);
void    CreateAllChildWindows (HWND hwnd);
LRESULT CALLBACK RottHelpProc(HWND, UINT, WPARAM, LPARAM);
void    WriteWinRottHelp (HWND hDlg);
void	FindROTTdemofiles();
int     MIDI_StoreSongPosition();
void    MIDI_RestoreSongPosition(int storedposition);

void    MoveScreenUpLeft();
void    MoveScreenUpRight();
void    MoveScreenDownLeft();
void    MoveScreenDownRight();

char        *tmpPICbuf;//used to strech and schrink mem pictures

extern char ApogeePath[256];
extern int	MusicMode;
extern int  iGLOBAL_SCREENWIDTH;// bna default value 800
extern int  iGLOBAL_SCREENHEIGHT;//bna default value 600
extern int  iGLOBAL_SCREENBWIDE ;
extern int  iG_SCREENWIDTH;// default screen width in bytes
extern int  viewheight;
extern int  viewwidth;
extern unsigned bufferofs;
extern unsigned displayofs;
//extern double dYZANGLELIMIT;

//extern int  NetErrorFlag;

HINSTANCE	hInst;
HWND		hMainWnd;
HWND		hwndButtonExit;
HWND		hwndButtonRunRott;
HWND		hwndStatic;
HWND		hwndRes320;
HWND		hwndRes640;
HWND		hwndRes800;
HWND		hwndStatic1;
HWND		hwndParaEdit;

HACCEL		ghAccel;
HWND		hWndList;
DWORD		dwCurrWidth, dwCurrHeight;
char		szAppName[] = "WinRott";
char		szDbgName[] = "WinRott.dbg";
char		szParameter[256];

int			argc;
char		*argv[40] ;
//int			L=0;
char		aDemoNames[10][40];
int 		iDemoNames;
int 		iCurrentDemoNames;

int         NbOfROTTMidiFilePlayed;
//extern  int iG_lastsongnumber;
//extern  int Oldsongnumber;
//int         bLoopSongFlag = 0;



//----------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
    MSG         msg;
    WNDCLASSEX  wc;
    HWND        hwnd;
    FILE        *stream;
    HACCEL      hAccel;
	char		tmp[255];

    //develop.h
//NetErrorFlag = 0;
    hInst = hInstance;
	NbOfROTTMidiFilePlayed = 0;

	lstrcpy (szParameter,szCmdLine);//store for later use

	SetRottScreenRes (800, 600);//default values

    stream = fopen(szDbgName, "w");
    fclose(stream);

    // current video setup data
    dwCurrWidth = GetSystemMetrics(SM_CXSCREEN);
    dwCurrHeight = GetSystemMetrics(SM_CYSCREEN);

  // Fill in window class structure with parameters that describe the main window.
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = CS_HREDRAW | CS_VREDRAW; // Class style(s).
    wc.lpfnWndProc   = (WNDPROC)WndProc;        // Window Procedure
    wc.cbClsExtra    = 0;                       // No per-class extra data.
    wc.cbWndExtra    = 0;                       // No per-window extra data.
    wc.hInstance     = hInstance;               // Owner of this class
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)); // Icon name from .RC
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1); // Default color
    wc.lpszMenuName  = (LPCSTR)IDC_WINROTTMENU;
    wc.lpszClassName = szAppName;               // Name to register as
	wc.hIconSm       = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));

    // Register the window class and return FALSE if unsuccesful.
    if (!RegisterClassEx(&wc))
    {
        //Assume we are running on NT where RegisterClassEx() is
        //not implemented, so let's try calling RegisterClass().
        if (!RegisterClass((LPWNDCLASS)&wc.style))
        	return FALSE;
    }
   
    // Create a main window for this application instance.
    hwnd = CreateWindow(szAppName,           // See RegisterClass() call
                        "WinRott",  // Text for window title bar
                        WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU, // Window styleWS_OVERLAPPEDWINDOW
                        CW_USEDEFAULT, CW_USEDEFAULT,	 // x, y
                        520, 430,	 // cx, cy
                        NULL,                // Overlapped has no parent
                        NULL,                // Use the window class menu
                        hInstance,           // This instance owns this window
                        NULL                 // Don't need data in WM_CREATE
    );
    hMainWnd = hwnd;

	CreateAllChildWindows (hwnd);

	// set default value in 800x600
	SendDlgItemMessage(hwnd,IDM_CHECK800,BM_SETCHECK,1,0);

	SetFocus(hwndButtonRunRott);

//	if (hWndList == NULL)
//		return NULL;

//	PlayResource("soundName");

    // Make the window visible & update its client area
    ShowWindow(hwnd, iCmdShow);// Show the window
    UpdateWindow(hwnd);        // Sends WM_PAINT message

//----GET OS VERSION
	// This is used to determine what OS we're on (Windows9X or Windows NT)
    GetWindowsVersion();




//----CHECK wad	VERSION and if all 3 rott files exists
#if (SHAREWARE)
	WriteLBtext("Starting WinRott version 1.22 SHAREWARE");
	if (access ("huntbgin.wad", 0) != 0) {
		WriteLBtext("Error, Could not find HUNTBGIN.WAD, aborting game");
		WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
		EnableWindow(hwndButtonRunRott,FALSE);
		goto Errexit;
	}else{
		WriteLBtext("Found HUNTBGIN.WAD");
		if (access ("huntbgin.rtl", 0) != 0) {
			WriteLBtext("Error, Could not find HUNTBGIN.RTL, aborting game");
			WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
			EnableWindow(hwndButtonRunRott,FALSE);
			goto Errexit;
		}else{
			WriteLBtext("Found HUNTBGIN.RTL");
			if (access ("huntbgin.wad", 0) != 0) {
				WriteLBtext("Error, Could not find HUNTBGIN.RTC, aborting game");
				WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
				EnableWindow(hwndButtonRunRott,FALSE);
				goto Errexit;
			}else{
				WriteLBtext("Found HUNTBGIN.RTC");
			}
		}
	}
#else
	WriteLBtext("Starting WinRott version 1.22 FULL VERSION");
	if (access ("darkwar.wad", 0) != 0) {
		WriteLBtext("Error, Could not find DARKWAR.WAD, aborting game");
		WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
		EnableWindow(hwndButtonRunRott,FALSE);
		goto Errexit;
	}else{
		WriteLBtext("Found DARKWAR.WAD");
		if (access ("darkwar.rtl", 0) != 0) {
			WriteLBtext("Error, Could not find DARKWAR.RTL, aborting game");
			WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
			EnableWindow(hwndButtonRunRott,FALSE);
			goto Errexit;
		}else{
			WriteLBtext("Found DARKWAR.RTL");
			if (access ("darkwar.wad", 0) != 0) {
				WriteLBtext("Error, Could not find DARKWAR.RTC, aborting game");
				WriteLBtext("Please reinstall ROTT Shareware or ROTT fullgame");
				EnableWindow(hwndButtonRunRott,FALSE);
				goto Errexit;
			}else{
				WriteLBtext("Found DARKWAR.RTC");
			}
		}
	}
#endif

	if (szCmdLine[0] != 0){//only print if theres any parameters 
		lstrcpy (tmp,"Program command line parameters = ");
		lstrcat (tmp,szCmdLine);	 
		WriteLBtext(tmp);
	}


	WriteLBtext("Converted to Windows High Resolution by Birger N. Andreasen");
	WriteLBtext("with help from Jonathan Bailey");
//  attemting to get DirectSound to work but failed
//  need to convert voc to wav
//	WriteLBtext("DirectSound conversion by Birger N. Andreasen");
//	WriteLBtext("Calling SetupDirectSound");
//  SetupDirectSound();
//	WriteLBtext("Calling ShutdownDirectSound");
//    ShutdownDirectSound();

	//WriteLBtext("");

	FindROTTdemofiles();

	WriteLBtext("");


	WriteLBtext("Push 'Run WinRott' button to start game "); 
	WriteLBtext("");
Errexit:;
    ShowCursor(TRUE);
    hAccel = LoadAccelerators(hInstance, (LPCTSTR)IDR_ACCELERATOR1);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccel, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

    SendMessage(hMainWnd, WM_CLOSE, 0, 0);
	return msg.wParam;
}
//----------------------------------------------------------------------
void ConvertRottParameters(LPSTR WinParameters)
{
	char *ptr;
	char tmp[256];
	int  linelen,i;
	
	//are there any parametres in textfield
	GetWindowText(hwndParaEdit,tmp,sizeof(tmp));
	if (tmp[0] != 0) {
		lstrcpy (WinParameters,tmp);
		if (WinParameters[0] != 0){//only print if theres any parameters
			lstrcpy (tmp,"Rott command line parameters = ");
			lstrcat (tmp,WinParameters);	 
			WriteLBtext(tmp);
		}
	}
	// convert windows parameters to C standard 
	ptr = WinParameters;//szParameter;
	argc = 1;//	argv[0],"WinRott.exe");
	linelen = lstrlen(WinParameters);
	for (i=0;i<=linelen;i++){
		if (*(ptr+i) != ' ') {
			argv[argc++] = (ptr+i);
			//move to next arg
			do {
				i++;
			}while ((*(ptr+i) != ' ')&&(*(ptr+i) != 0));
			*(ptr+i) = 0;
		}
	}
	argv[argc] = 0;
	//*****************************************

}
//----------------------------------------------------------------------
void ReadDelay(long delay)
{
	//a delay so user has time to read text on screen
	unsigned long Tick = GetTickCount() + delay;
	do {
	}while(GetTickCount()<Tick);
}
//----------------------------------------------------------------------
void WriteLBtext(LPSTR txt)
{
	int slen;
	char buf[512];
	//remove garbage at txt_end
	lstrcpy(buf,txt);
	slen = lstrlen(buf);
	if (*(buf+slen-1)<=20){
		*(buf+slen-1)=0;
	}
	if (hWndList == NULL){return;}
	SendMessage(hWndList,LB_ADDSTRING , 0, (LPARAM)buf);
    UpdateWindow(hWndList);        // Sends WM_PAINT message
	ReadDelay(5);
}
//----------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
//	PAINTSTRUCT ps;
//	HDC hdc;
    static HDC         hDC;
    static PAINTSTRUCT ps;
//    static event_t     event;
//    static unsigned char KeyPress;
//    static int         scancode;
//	       char buf[255];


		switch(message)
		{
		case WM_CREATE:
			break;
        case WM_KEYDOWN: 
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{

			    case IDM_PARAMETER_EDIT:
		
	//			   GetWindowText(hwndParaEdit ,buf,255);
				   //SendMessage((HWND) hwndParaEdit,EM_GETSEL,(WPARAM) wP,(LPARAM) lP);
	//			   L = lstrlen (buf);
				   break;
				case IDM_CHECK320:
				   SendDlgItemMessage(hWnd,IDM_CHECK320,BM_SETCHECK,1,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK640,BM_SETCHECK,0,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK800,BM_SETCHECK,0,0);
				   SetRottScreenRes (320, 200);
				   break;
				case IDM_CHECK640:
				   SendDlgItemMessage(hWnd,IDM_CHECK320,BM_SETCHECK,0,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK640,BM_SETCHECK,1,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK800,BM_SETCHECK,0,0);
				   SetRottScreenRes (640, 480);
				   break;			
				case IDM_CHECK800:
				   SendDlgItemMessage(hWnd,IDM_CHECK320,BM_SETCHECK,0,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK640,BM_SETCHECK,0,0);
				   SendDlgItemMessage(hWnd,IDM_CHECK800,BM_SETCHECK,1,0);
				   SetRottScreenRes (800, 600);
				   break;		
				case ID_HELP_ROTTHELP:
				   DialogBox(hInst, (LPCTSTR)IDD_DIALOG1, hWnd, (DLGPROC)RottHelpProc);
				   break;
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_RUNROTT:
				   ConvertRottParameters(szParameter);
				   ShowCursor(FALSE);
				   tmpPICbuf =  GlobalAlloc(GMEM_FIXED,iGLOBAL_SCREENHEIGHT*iGLOBAL_SCREENWIDTH);
				   main(argc,argv); // jump to ROTT main loop
				   GlobalUnlock(tmpPICbuf);//release mem
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
		/*	hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);*/
				break;
		case MM_MCINOTIFY:
			if (wParam == MCI_NOTIFY_SUCCESSFUL)
			{
				StopMidiMusic();
				PlayROTTMidiFile("rottsong.mid",1);
			}
			if (wParam == MCI_NOTIFY_FAILURE)
			{


			}
			if (wParam == MCI_STATUS)
			{
				wmId = 0;
				wmId = wmId  ;
			}
			break;
	} 
    
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//----------------------------------------------------------------------
// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

//----------------------------------------------------------------------
// Mesage handler for RottHelpProc box.
LRESULT CALLBACK RottHelpProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			    WriteWinRottHelp (hDlg);
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}



//----------------------------------------------------------------------
void FindROTTdemofiles()
{
	WIN32_FIND_DATA	FileData; 
	HANDLE			hSearch; 
//	DWORD			dwAttrs; 
	BOOL			fFinished = FALSE; 
	FILE			*dmofile;
	char			buffer[25];

	iDemoNames = -1; //global counter
	iCurrentDemoNames = -1;// global cnt used later to store last played demo

	// Start searching for .DMO files in the current directory. 
	hSearch = FindFirstFile("*.dmo", &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		WriteLBtext("No rott demo files found."); 
		return;
	} 

	// Copy each .DMO filename to the array 
	while (!fFinished) 
	{ 
		if (lstrlen(FileData.cFileName) < 40) { //filename must not exxed 40 chars

			//check if correct demo type or game will crash
			if((dmofile=fopen(FileData.cFileName, "r")))
			{
				fgets(buffer, sizeof(buffer), dmofile);
				fclose(dmofile);
				buffer[5]=0;
			}
			#if (SHAREWARE == 1)
				if (lstrcmp(buffer,"DMOSW")==0) { //not a shareware demo version
					if (iDemoNames < 10) { // store max 10 names
						iDemoNames++;
						lstrcpy(aDemoNames[iDemoNames], FileData.cFileName); 
					}
				}
			#else
				if (lstrcmp(buffer,"DMOFL")==0) { //not a reg demo version
					if (iDemoNames < 10) { // store max 10 names
						iDemoNames++;
						lstrcpy(aDemoNames[iDemoNames], FileData.cFileName); 
					}
				}
			#endif
		}

		if (!FindNextFile(hSearch, &FileData)) 
		{
			if (GetLastError() == ERROR_NO_MORE_FILES) 
			{ 
				fFinished = TRUE; 
			} 
			else 
			{ 
				WriteLBtext("Couldn't find next demo file."); 
			} 
		}
	} 
 
	// Close the search handle. 
 	if (!FindClose(hSearch)) 
	{ 
		WriteLBtext("Couldn't close search handle."); 
	} 

	if (iDemoNames >= 0) {
		iCurrentDemoNames = 0;
	}



}



//----------------------------------------------------------------------
//luckey for me that I am not programmin a 386 or the next
//4 function would never have worked. bna++
extern int     viewsize;
void MoveScreenUpLeft()
{
	int startX,startY,startoffset;
    byte  *Ycnt,*b;
//   SetTextMode (  );
    b=(byte *)bufferofs;
	b += (((iGLOBAL_SCREENHEIGHT-viewheight)/2)*iGLOBAL_SCREENWIDTH)+((iGLOBAL_SCREENWIDTH-viewwidth)/2);
	if (viewsize == 8) {b += 8*iGLOBAL_SCREENWIDTH;}
	startX = 3; //take 3 pixels to the right
	startY = 3; //take 3 lines down
	startoffset = (startY*iGLOBAL_SCREENWIDTH)+startX;

	for (Ycnt=b;Ycnt<b+((viewheight-startY)*iGLOBAL_SCREENWIDTH);Ycnt+=iGLOBAL_SCREENWIDTH){
		memcpy(Ycnt,Ycnt+startoffset, viewwidth-startX);
	}
}
//----------------------------------------------------------------------
void MoveScreenDownLeft()
{
	int startX,startY,startoffset;
    byte  *Ycnt,*b;
//   SetTextMode (  );
    b=(byte *)bufferofs;
	b += (((iGLOBAL_SCREENHEIGHT-viewheight)/2)*iGLOBAL_SCREENWIDTH)+((iGLOBAL_SCREENWIDTH-viewwidth)/2);
	if (viewsize == 8) {b += 8*iGLOBAL_SCREENWIDTH;}
	startX = 3; //take 3 pixels to the right
	startY = 3; //take 3 lines down
	startoffset = (startY*iGLOBAL_SCREENWIDTH);//+startX;

	//Ycnt starts in botton of screen and copys lines upwards
	for (Ycnt=b+((viewheight-startY-1)*iGLOBAL_SCREENWIDTH);Ycnt>b;Ycnt-=iGLOBAL_SCREENWIDTH){
		memcpy(Ycnt+startoffset,Ycnt+startX,viewwidth-startX);
	}
}
//----------------------------------------------------------------------
void MoveScreenUpRight()
{
	int startX,startY,startoffset;
    byte  *Ycnt,*b;
//   SetTextMode (  );
    b=(byte *)bufferofs;

	b += (((iGLOBAL_SCREENHEIGHT-viewheight)/2)*iGLOBAL_SCREENWIDTH)+((iGLOBAL_SCREENWIDTH-viewwidth)/2);
	if (viewsize == 8) {b += 8*iGLOBAL_SCREENWIDTH;}
	startX = 3; //take 3 pixels to the right
	startY = 3; //take 3 lines down
	startoffset = (startY*iGLOBAL_SCREENWIDTH);//+startX;

	for (Ycnt=b;Ycnt<b+((viewheight-startY)*iGLOBAL_SCREENWIDTH);Ycnt+=iGLOBAL_SCREENWIDTH){
		memcpy(Ycnt+startX,Ycnt+startoffset, viewwidth-startX);
	}
}
//----------------------------------------------------------------------
void MoveScreenDownRight()
{
	int startX,startY,startoffset;
    byte  *Ycnt,*b;
//   SetTextMode (  );
    b=(byte *)bufferofs;

	b += (((iGLOBAL_SCREENHEIGHT-viewheight)/2)*iGLOBAL_SCREENWIDTH)+((iGLOBAL_SCREENWIDTH-viewwidth)/2);
	if (viewsize == 8) {b += 8*iGLOBAL_SCREENWIDTH;}
	startX = 3; //take 3 pixels to the right
	startY = 3; //take 3 lines down
	startoffset = (startY*iGLOBAL_SCREENWIDTH)+startX;

	//Ycnt starts in botton of screen and copys lines upwards
	for (Ycnt=b+((viewheight-startY-1)*iGLOBAL_SCREENWIDTH);Ycnt>b;Ycnt-=iGLOBAL_SCREENWIDTH){
		memcpy(Ycnt+startoffset,Ycnt,viewwidth-startX);
	}
}


//----------------------------------------------------------------------
void WriteDebug(char *Message)
{
    FILE *stream;

    stream = fopen(szDbgName, "a+");
    fprintf(stream, "%s", Message);
    fclose(stream);
}
//----------------------------------------------------------------------
void GetWindowsVersion()
{
    OSVERSIONINFO OSVersionInfo;
    FILE *stream;
	char buf[512];

    stream = fopen(szDbgName, "a+");

    OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVersionInfo);
    GetVersionEx(&OSVersionInfo);

    switch(OSVersionInfo.dwPlatformId)
	{
	case VER_PLATFORM_WIN32s:
		sprintf(buf, "Platform is Windows %d.%02d\n",
			OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion);
		WriteLBtext(buf);
		fprintf(stream, "Platform is Windows %d.%02d\n",
			OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion);
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		fprintf(stream, "Platform is Windows 9X ");
		sprintf(buf, "Platform is Windows 9X ,Version %d.%02d.%d\n", OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion,
			OSVersionInfo.dwBuildNumber & 0xFFFF);
		WriteLBtext(buf);
		fprintf(stream, "Version %d.%02d.%d\n", OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion,
			OSVersionInfo.dwBuildNumber & 0xFFFF);
		break;
	case VER_PLATFORM_WIN32_NT:
		sprintf(buf, "Platform is Windows NT ,Version %d.%02d ", OSVersionInfo.dwMajorVersion, OSVersionInfo.dwMinorVersion);
		WriteLBtext(buf);		
		sprintf(buf, "Build %d\n", OSVersionInfo.dwBuildNumber & 0xFFFF);
		WriteLBtext(buf);

		fprintf(stream, "Platform is Windows NT ");
		fprintf(stream, "Version %d.%02d ", OSVersionInfo.dwMajorVersion, OSVersionInfo.dwMinorVersion);
		fprintf(stream, "Build %d\n", OSVersionInfo.dwBuildNumber & 0xFFFF);
		break;
	}
//    if(strlen(OSVersionInfo.szCSDVersion) > 0)
//		fprintf(stream, "Windows Info: %s\n", OSVersionInfo.szCSDVersion);
    fclose(stream);
}

//#define FINEANGLES                        2048
void SetRottScreenRes (int Width, int Height) 
{
	
	iGLOBAL_SCREENWIDTH = Width;
	iGLOBAL_SCREENHEIGHT = Height;


    iGLOBAL_SCREENBWIDE = iGLOBAL_SCREENWIDTH*(96/320);
	iG_SCREENWIDTH = iGLOBAL_SCREENWIDTH*(96/320);;// default screen width in bytes

	if (iGLOBAL_SCREENWIDTH == 320) {
		iGLOBAL_FOCALWIDTH = 160;
		dGLOBAL_FPFOCALWIDTH = 160.0; 
		iGLOBAL_HEALTH_X = 20;
		iGLOBAL_HEALTH_Y = 185;
		iGLOBAL_AMMO_X = 300;
		iGLOBAL_AMMO_Y = 184;
	}
	if (iGLOBAL_SCREENWIDTH == 640) {
		iGLOBAL_FOCALWIDTH = 180;
		dGLOBAL_FPFOCALWIDTH = 180.0 ;
		iGLOBAL_HEALTH_X = 40;//20*2;
		iGLOBAL_HEALTH_Y = 466;//(185*2)+16;
		iGLOBAL_AMMO_X = 600;//300*2;
		iGLOBAL_AMMO_Y = 466;//(184*2)+16;
	}
	if (iGLOBAL_SCREENWIDTH == 800) {
		iGLOBAL_FOCALWIDTH = 200;
		dGLOBAL_FPFOCALWIDTH = 200.0 ;
		iGLOBAL_HEALTH_X = 40;//20*2;
		iGLOBAL_HEALTH_Y = 585;//(185/200)*600;
		iGLOBAL_AMMO_X = 750;//(300/320)*800;
		iGLOBAL_AMMO_Y = 585;//(184/200)*600;
	}

	//dYZANGLELIMIT = (12*FINEANGLES/360);
	//#define YZANGLELIMIT  (12*FINEANGLES/360)//bna--(30*FINEANGLES/360)

	GetCurrentDirectory(sizeof(ApogeePath),ApogeePath);// curent directory name

}

void CreateAllChildWindows (HWND hwnd)
{
	HGDIOBJ		font;
	
	hWndList = CreateWindowEx(0L, "LISTBOX","",
		  LBS_NOTIFY | WS_BORDER | WS_VSCROLL | LBS_USETABSTOPS | WS_CHILD | WS_VISIBLE,
		  2, 2,
		  512, 310,
		  (HWND)hwnd,
		  NULL,
		  hInst,
		  NULL );
	hwndButtonRunRott = CreateWindow("BUTTON","Run WinRott",WS_VISIBLE | WS_CHILD| BS_DEFPUSHBUTTON ,
		400, 315,     // starting x position and starting y position     
		100,25,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_RUNROTT,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 
	hwndButtonExit = CreateWindow("BUTTON","Exit",WS_VISIBLE | WS_CHILD ,
	    400,350,     // starting x position and starting y position     
		100,25,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_EXIT,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 
    //-------------------------------------------------------------------------
	hwndStatic = CreateWindow("STATIC","Resolution:",WS_VISIBLE | WS_CHILD ,
		10,310,     // starting x position and starting y position     
		180,20,    // button width     
		hwnd,       // parent window     
		NULL,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 

	hwndRes320 = CreateWindow("BUTTON","320x200",WS_VISIBLE | WS_CHILD |BS_RADIOBUTTON ,
		10,322,     // starting x position and starting y position     
		80,20,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_CHECK320,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 
	hwndRes640 = CreateWindow("BUTTON","640x480",WS_VISIBLE | WS_CHILD |BS_RADIOBUTTON ,
		100,322,     // starting x position and starting y position     
		80,20,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_CHECK640,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 
	hwndRes800 = CreateWindow("BUTTON","800x600",WS_VISIBLE | WS_CHILD |BS_RADIOBUTTON ,
		190,322,     // starting x position and starting y position     
		80,20,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_CHECK800,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 
    //-------------------------------------------------------------------------
	hwndStatic1 = CreateWindow("STATIC","Rott Parameters:",WS_VISIBLE | WS_CHILD ,
		10,342,     // starting x position and starting y position     
		180,20,    // button width     
		hwnd,       // parent window     
		NULL,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 

	hwndParaEdit = CreateWindow("EDIT","",WS_VISIBLE | WS_CHILD |WS_BORDER|ES_AUTOHSCROLL| ES_WANTRETURN|ES_MULTILINE  ,
		10,356,     // starting x position and starting y position     
		260,20,    // button width     
		hwnd,       // parent window     
		(HMENU)IDM_PARAMETER_EDIT,   // No menu (identifier)
		(HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE), 
		NULL);      // pointer not needed 



	font = GetStockObject(ANSI_FIXED_FONT);
	SendMessage(hWndList,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndButtonRunRott,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndButtonExit,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndStatic,WM_SETFONT, (UINT)font, 0L);

	SendMessage(hwndRes320,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndRes640,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndRes800,WM_SETFONT, (UINT)font, 0L);

	SendMessage(hwndStatic1,WM_SETFONT, (UINT)font, 0L);
	SendMessage(hwndParaEdit,WM_SETFONT, (UINT)font, 0L);


}

void WriteWinRottHelp (HWND hDlg)
{
//funny how I could not get "\n" to work
char  HelpTmp[] =

      "      Rise of the Triad  (c) 1995 Apogee Software## ##\
COMMAND LINE PARAMETERS:##\
      ##\
         WEAPONSCALE - Scale weapon up or down.##\
                     - next parameter is scale from 168->336##\
         FILERTL     - used to load Userlevels (RTL files)##\
                     - next parameter is RTL filename##\
         FILERTC     - used to load Battlelevels (RTC files)##\
                     - next parameter is RTC filename##\
         FILE        - used to load Extern WAD files##\
                     - next parameter is WAD filename##\
         SPACEBALL   - Enable check for Spaceball.##\
         NOJOYS      - Disable check for joystick.##\
         NOMOUSE     - Disable check for mouse.##\
         CYBERMAN    - Enable check for Cyberman.##\
         ASSASSIN    - Enable check for Wingman Assassin.##\
         VER         - Version number.##\
         MAPSTATS    - Dump Map statistics to ERROR.##\
         TILESTATS   - Dump Tile statistics to ERROR.##\
         MONO        - Enable mono-monitor support.##\
         NET         - Start TCP/UDP IP netgame.##\
                     - next parameter is client IP or name##\
         SERVER      - used with net parameter to ##\
                     - specifie to startup as server##\
         SCREENSHOTS - Clean screen capture for shots.##\
         PAUSE       - Pauses startup screen information.##\
         SOUNDSETUP  - Setup sound for ROTT##\
         ENABLEVR    - Enable VR helmet input devices##\
         NOECHO      - Turn off sound reverb##\
         DEMOEXIT    - Exit program when demo is terminated##\
         WARP        - Warp to specific ROTT level##\
                       next paramater is level to start on##\
         TIMELIMIT   - Play ROTT in time limit mode##\
                       next paramater is time in seconds##\
         MAXTIMELIMIT- Maximimum time to count down from##\
                       next paramater is time in seconds##\
         DOPEFISH    - ?##"
		 " ##"
		 "CONTROLS##"
		 "         Arrows           - Move##"
		 "         Ctrl             - Fire##"
		 "         Comma/Alt+left   - Sidestep Left##"
		 "         Period/Alt+right - Sidestep Right##"
		 "         Shift            - Run/Turn faster##"
		 "         Space            - Use/Open##"
		 "         1-4              - Choose Weapon##"
		 "         5-6              - Scale Weapon Up/Down##"
		 "         Enter            - Swap Weapon##"
		 "         Backspace        - Turn 180##"
		 "         Delete           - Drop Weapon##"
		 "         +/-              - Change Viewsize##"
		 "         PgUp/PgDn        - Look Up/Down##"
		 "         Home/End         - Aim Up/Down##"
		 "         [ ]              - Sound Volumen##"
		 "         ( )              - Music Volumen##"
		 "         Tab              - Enter Automapper##"
		 " ##"
		 "AUTO-MAPPER##"
		 "         Arrows           - Scroll around##"
		 "         PgUp             - Zoom Out##"
		 "         PgDn             - Zoom In##"
		 "         Tab              - Exit Auto-Mapper##"
		 " ##"
		 "HOTKEYS##"
		 "         F1               - Help##"
		 "         F2               - Save Game##"
		 "         F3               - Restore Game##"
		 "         F4               - Controls/Sound/Music##"
		 "         F5               - Change Detail Level##"
		 "         F6               - Quick Save##"
		 "         F7               - Messages On/Off##"
		 "         F8               - End Game##"
		 "         F9               - Quick Load##"
		 "         F10              - Quit##"
		 "         F11              - Gamma Correction##"
		 " ##"
		 "COMM-BAT##"
		 "         F1 - F10         - RemoteRidicule(tm) sounds##"
		 "         F12              - Live RemoteRidicule##"
		 "         T                - Type message to all##"
		 "         Z                - Type directed message##"
		 "         Tab              - Toggle KillCount display##"
		 " ##"
		 "SCREENSHOOT##"
		 "         Alt+C            - Screenshoot in BMP format##"
		 "         Alt+V            - Screenshoot in PCX format##"
		 "DEMO##"
		 "         Alt+R            - Starts demo recording##"
		 "         Alt+E            - Ends a demo recording##";	

	int i;
	HGDIOBJ font = GetStockObject(ANSI_FIXED_FONT);
	SendMessage(GetDlgItem(hDlg,IDC_EDIT1),WM_SETFONT, (UINT)font, 0L);
	SendMessage(GetDlgItem(hDlg,IDOK),WM_SETFONT, (UINT)font, 0L);
	for (i=0;i<sizeof(HelpTmp);i++) {//change newline mannuely
		if (HelpTmp[i] == '#') {
			HelpTmp[i++] = 13;
			HelpTmp[i++] = 10;
		}
	}

    SendMessage(GetDlgItem(hDlg,IDC_EDIT1), WM_SETTEXT, 0, (LPARAM) HelpTmp); 
}





//----------------------------------------------------------------------
// DIRECTSOUND - Sound effects
//----------------------------------------------------------------------

BOOL SetupDirectSound()
   {
    HRESULT        hresult;
    int            buff;
    DSBUFFERDESC   dsbdesc;
    WAVEFORMATEX   wfx;

    // Create an instance of DirectSound
    hresult = DirectSoundCreate(NULL, &lpds, NULL);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSoundCreate");
        for (buff = 0; buff < NUM_DSBUFFERS; buff++)
           lpdsbuffer[buff] = 0;
        return FALSE;
       }

    // Set the cooperative level so it doesn't get confused
    hresult = lpds->lpVtbl->SetCooperativeLevel(lpds, hMainWnd, DSSCL_EXCLUSIVE);
    if (hresult != DS_OK)
       DS_Error(hresult, "DirectSound.SetCooperativeLevel");

    // Set up DSBUFFERDESC structure.
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));  // Zero it out.
    dsbdesc.dwSize              = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags             = DSBCAPS_PRIMARYBUFFER;
    dsbdesc.dwBufferBytes       = 0;
    dsbdesc.lpwfxFormat         = NULL;

    hresult = lpds->lpVtbl->CreateSoundBuffer(lpds, &dsbdesc, &lpdsbPrimary, NULL);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSound.CreateSoundBuffer - Primary");
       }

    // Set up wave format structure.
    memset( &wfx, 0, sizeof(WAVEFORMATEX) );
    wfx.wFormatTag         = WAVE_FORMAT_PCM;      
    wfx.nChannels          = 2;
    wfx.nSamplesPerSec     = 11025;
    wfx.nAvgBytesPerSec    = 11025*2*1;
    wfx.nBlockAlign        = 2; // ?
    wfx.wBitsPerSample     = (WORD)8;
    wfx.cbSize             = 0;

    hresult = lpdsbPrimary->lpVtbl->SetFormat(lpdsbPrimary, &wfx);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSound.SetFormat - Primary");
       }

    // Set the cooperative level so it doesn't get confused
    hresult = lpds->lpVtbl->SetCooperativeLevel(lpds, hMainWnd, DSSCL_NORMAL);
    if (hresult != DS_OK)
       DS_Error(hresult, "DirectSound.SetCooperativeLevel");

    return(TRUE);
   }

#define DSBCAPS_CTRLDEFAULT 224
void CreateSoundBuffer(int Channel, int length, unsigned char *data)
   {
    HRESULT        hresult;
    //int            buff;
    DSBUFFERDESC   dsbdesc;
    PCMWAVEFORMAT  pcmwf;
    void          *buffer, *buff2;
    DWORD          size1, size2;

    if (Channel > NUM_DSBUFFERS)
       {
        WriteDebug("Invalid sound effect...\n");
        return;
       }

    // Set up wave format structure.
    memset( &pcmwf, 0, sizeof(PCMWAVEFORMAT) );
    pcmwf.wf.wFormatTag         = WAVE_FORMAT_PCM;      
    pcmwf.wf.nChannels          = 1;
    pcmwf.wf.nSamplesPerSec     = 11025;
    pcmwf.wf.nBlockAlign        = 1; // ?
    pcmwf.wf.nAvgBytesPerSec    = 11025*1*1;
    pcmwf.wBitsPerSample        = (WORD)8;

    // Set up DSBUFFERDESC structure.
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));  // Zero it out.
    dsbdesc.dwSize              = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags             = DSBCAPS_CTRLDEFAULT|DSBCAPS_CTRLPOSITIONNOTIFY;
    dsbdesc.dwBufferBytes       = length;
    dsbdesc.lpwfxFormat         = (LPWAVEFORMATEX)&pcmwf;

    if ((hresult = lpds->lpVtbl->CreateSoundBuffer(lpds, &dsbdesc, &lpdsbuffer[Channel], NULL)) != DS_OK)
       {
        DS_Error(hresult, "DirectSound.CreateSoundBuffer");
        return;
       }

    hresult = lpdsbuffer[Channel]->lpVtbl->Lock(lpdsbuffer[Channel],0,length,&buffer,&size1,&buff2,&size2,DSBLOCK_ENTIREBUFFER );
    if (hresult == DS_OK)
       {
        memcpy(buffer, data, length);
        hresult = lpdsbuffer[Channel]->lpVtbl->Unlock(lpdsbuffer[Channel],buffer,length,buff2,size2);
        if (hresult != DS_OK){
           DS_Error(hresult, "lpdsbuffer.Unlock");
		}
       }
    else
       {
        DS_Error(hresult, "lpdsbuffer.Lock");
       }
   }

void ShutdownDirectSound(void)
{
    int buff;
    DWORD BufferStatus;

    for(buff = 0; buff < NUM_DSBUFFERS; buff++)
	{
        if(lpdsbuffer[buff] != 0)
		{
            BufferStatus = DSBSTATUS_PLAYING;
            while (BufferStatus == DSBSTATUS_PLAYING)
                lpdsbuffer[buff]->lpVtbl->GetStatus(lpdsbuffer[buff], &BufferStatus);
            RELEASE(lpdsbuffer[buff]);
		}
	}
    if(lpdsbPrimary != NULL) RELEASE(lpdsbPrimary);
    if(lpds != NULL) RELEASE(lpds);
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------


BOOL PlayResource(LPSTR lpName) 
{
	BOOL bRtn;     
	LPSTR lpRes; 
    HANDLE hResInfo,hRes;      // Find the WAVE resource.  
    
	hResInfo = FindResource(hInst, lpName, "WAVE");     
	if (hResInfo == NULL) 
        return FALSE;      // Load the WAVE resource.  
    hRes = LoadResource(hInst, hResInfo);     
	if (hRes == NULL) 
        return FALSE;      // Lock the WAVE resource and play it.  
    lpRes = LockResource(hRes);   

	if (lpRes != NULL) { 
        bRtn = sndPlaySound(lpRes, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);         
		UnlockResource(hRes);     
	}     
	else 
        bRtn = 0;      // Free the WAVE resource and return success or failure. 
     FreeResource(hRes);     
	 return bRtn; 
} 
//----------------------------------------------------------------------
BOOL PlayMemSound(char *memptr) 
{  
	int i;
	BOOL bRtn;     
	LPSTR lpRes,lpMem; 
    HANDLE hResInfo,hRes;      // Find the WAVE resource.  
    
	hResInfo = FindResource(hInst, "soundName", "WAVE");     
	if (hResInfo == NULL) 
        return FALSE;      // Load the WAVE resource.  
    hRes = LoadResource(hInst, hResInfo);     
	if (hRes == NULL) 
        return FALSE;      // Lock the WAVE resource and play it.  
    lpRes = LockResource(hRes);  
	
	lpMem = lpRes + 0x2C;
	//copy ptr data tp lpRes
	for (i=0;i<3600;i++){
		*lpMem++ = *memptr++;
	}

	if (lpRes != NULL) { 
        bRtn = sndPlaySound(lpRes, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);         
		UnlockResource(hRes);     }     
	else 
        bRtn = 0;      // Free the WAVE resource and return success or failure. 
     FreeResource(hRes);     
	 return bRtn; 
}



// some of next sections code is stolen from windoom by Bruce A. Lewis.
HWND hWndsound;
// Local define needed only for error message capture and display
#define     MCIMSGLEN  128
char        MidiMsg[MCIMSGLEN+1];


BOOL MidiPlay(HWND hWnd, MIDI_Data_t *mdd)
{
    MCI_OPEN_PARMS     open;
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;
    UINT               uDeviceId;

    hWndsound = hWnd;

	if (access(mdd->szMidiFile, 4) != 0)
	{
        mdd->MidiStatus = midi_nofile;
        return(FALSE);
	}

    open.dwCallback       = (DWORD)hWnd;
    open.lpstrDeviceType  = "sequencer";
    open.lpstrElementName = mdd->szMidiFile;

    MCI_Error = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)&open);

    if (MCI_Error)
	{
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
	}

    // play back midi file
    //......................
	uDeviceId = open.wDeviceID;
    play.dwCallback = (DWORD)hWnd;
                           
    MCI_Error = mciSendCommand(uDeviceId, MCI_PLAY, MCI_NOTIFY, (DWORD)&play);
    if (MCI_Error)
	{
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mciSendCommand(uDeviceId, MCI_CLOSE, 0, (DWORD)NULL);
        mdd->MidiError = MCI_Error;
        return(FALSE);
	}
    mdd->MidiDevice = uDeviceId;
    mdd->MidiStatus = midi_play;

	

    return(TRUE);
}  //midiplay



int MIDI_StoreSongPosition()
{
    MCI_STATUS_PARMS   status;
    MCIERROR           MCI_Error;
	MCI_SET_PARMS      set;

    MidiData.MidiError = 0;
    set.dwTimeFormat   = MCI_FORMAT_MILLISECONDS;
    mciSendCommand(MidiData.MidiDevice, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID)&set);

    status.dwCallback  = (DWORD)hMainWnd;
    status.dwItem = MCI_STATUS_POSITION;

    MCI_Error = mciSendCommand(MidiData.MidiDevice, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)&status);
	return status.dwReturn; 
}


void MIDI_RestoreSongPosition(int storedposition)
{
	MidiData.MidiPosition = storedposition;
	MidiResume(hMainWnd, &MidiData);
}





BOOL MidiReplay(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;

    play.dwCallback = (DWORD)hWnd;
    play.dwFrom = 0;
                           
    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_PLAY, MCI_NOTIFY | MCI_FROM, (DWORD)&play);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        return(FALSE);
       }
    return(TRUE);
   }

BOOL MidiPause(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_SET_PARMS      set;
    MCI_STATUS_PARMS   status;
    MCIERROR           MCI_Error;

    mdd->MidiError = 0;
    set.dwTimeFormat   = MCI_FORMAT_MILLISECONDS;
    mciSendCommand(mdd->MidiDevice, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID)&set);

    status.dwCallback  = (DWORD)hWnd;
    status.dwItem = MCI_STATUS_POSITION;

    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)&status);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        strcat(MidiMsg, "\nMidiPause");
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
       }
    mdd->MidiPosition = status.dwReturn;
    mciSendCommand(mdd->MidiDevice, MCI_STOP, 0, (DWORD)NULL);
    mdd->MidiStatus = midi_pause;
    return(TRUE);
   }

BOOL MidiResume(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_SET_PARMS      set;
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;

    mdd->MidiError = 0;
    set.dwTimeFormat   = MCI_FORMAT_MILLISECONDS;
    mciSendCommand(mdd->MidiDevice, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID) &set);

    play.dwCallback = (DWORD)hWnd;
    play.dwTo = 0;
    play.dwFrom = mdd->MidiPosition;
    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_PLAY, MCI_NOTIFY | MCI_FROM, (DWORD)(LPVOID)&play);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        strcat(MidiMsg, "\nMidiResume");
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
       }
    mdd->MidiStatus = midi_play;
    return(TRUE);
   }

void MidiStop(MIDI_Data_t *mdd)
   {
    mciSendCommand(mdd->MidiDevice, MCI_STOP, 0, (DWORD)NULL);
    mciSendCommand(mdd->MidiDevice, MCI_CLOSE, 0, (DWORD)NULL);
    mdd->MidiStatus = midi_stop;
   }


int IsROTTMidiPlaying()
{
	if ( MidiData.MidiStatus == midi_play) {
		return TRUE;
	}else{
		return FALSE;
	}
}

int PlayROTTMidiFile(char *song, boolean loop)
{
	NbOfROTTMidiFilePlayed++;
	strcpy(MidiData.szMidiFile, song);
    MidiPlay(hMainWnd, &MidiData);

	return 0;
}


void PlayMidiMusic()
   {
    if ((MidiData.MidiStatus != midi_play) && (MidiData.MidiStatus != midi_pause))
       {
        MidiPlay(hMainWnd, &MidiData);
       }
   }


void PauseResumeMusic()
   {
    switch(MidiData.MidiStatus)
       {
        case midi_play:
             MidiPause(hMainWnd, &MidiData);
             break;
        case midi_pause:
             MidiResume(hMainWnd, &MidiData);
             break;
       }
  
   }

int StopMidiMusic()
{
    if(MidiData.MidiStatus != midi_stop)
	{
        MidiStop(&MidiData);
	}
	return 0;
}



long GetSetVolumeMidi (long newvol, int SetGetFLAG) // 0 = get  1 = set
{	
	// return = actuell midi value by get 
	int SoundScale = 255;

    MMRESULT rc;              // Return code.
    HMIXER hMixer;            // Mixer handle used in mixer API calls.
    MIXERCONTROL mxc;         // Holds the mixer control data.
    MIXERLINE mxl;            // Holds the mixer line data.
    MIXERLINECONTROLS mxlc;   // Obtains the mixer control.
	MIXERCONTROLDETAILS mxcd;             // Gets the control values.
    MIXERCONTROLDETAILS_SIGNED volStruct; // Gets the control values.
	long volume;                          // Holds the final volume value.

	// Open the mixer. This opens the mixer with a deviceID of 0. If you
    // have a single sound card/mixer, then this will open it. If you have
    // multiple sound cards/mixers, the deviceIDs will be 0, 1, 2, and
    // so on.    
	rc = mixerOpen(&hMixer, 0,0,0,0);
    if (MMSYSERR_NOERROR == rc) {        
		// Couldn't open the mixer. 
		//return 0;
	}

    // Initialize MIXERLINE structure.    
	ZeroMemory(&mxl,sizeof(mxl));
    mxl.cbStruct = sizeof(mxl);

    // Specify the line you want to get. You are getting the input line
    // here. If you want to get the output line, you need to use
    // MIXERLINE_COMPONENTTYPE_SRC_MIDIOUT.= 4100 = midi value
    mxl.dwComponentType = 4100;//MIXERLINE_COMPONENTTYPE_DST_WAVEIN;

    rc = mixerGetLineInfo((HMIXEROBJ)hMixer, &mxl,MIXER_GETLINEINFOF_COMPONENTTYPE);
    if (MMSYSERR_NOERROR == rc) {        
		// Couldn't get the mixer line. 
		//return 0;
	}

	// Get the control.    
	ZeroMemory(&mxlc, sizeof(mxlc));
    mxlc.cbStruct = sizeof(mxlc);    
	mxlc.dwLineID = mxl.dwLineID;
    mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
    mxlc.cControls = 1;    
	mxlc.cbmxctrl = sizeof(mxc);   
	mxlc.pamxctrl = &mxc;
    ZeroMemory(&mxc, sizeof(mxc));    
	mxc.cbStruct = sizeof(mxc);
    rc = mixerGetLineControls((HMIXEROBJ)hMixer,&mxlc,MIXER_GETLINECONTROLSF_ONEBYTYPE);
    if (MMSYSERR_NOERROR == rc) {   
		// Couldn't get the control.
		//mixerClose(hMixer);
		//return 0;
	}
    // After successfully getting the dwControlType control, the volume range
    // will be specified by mxc.Bounds.lMinimum to mxc.Bounds.lMaximum.


	if (SetGetFLAG == 0) {  // caller wants a actuel sound value
		// Initialize the MIXERCONTROLDETAILS structure
		ZeroMemory(&mxcd, sizeof(mxcd));    
		mxcd.cbStruct = sizeof(mxcd);
		mxcd.cbDetails = sizeof(volStruct);    
		mxcd.dwControlID = mxc.dwControlID;
		mxcd.paDetails = &volStruct;   
		mxcd.cChannels = 1;
		// Get the current value of the dwControlType control. 
		rc = mixerGetControlDetails((HMIXEROBJ)hMixer, &mxcd,
                                 MIXER_GETCONTROLDETAILSF_VALUE);
		if (MMSYSERR_NOERROR == rc) {        
			// Couldn't get the current volume.
			//mixerClose(hMixer);
			//return 0;

	    }    
		volume = volStruct.lValue;    // Get the absolute value of the volume.
		if (volume < 0)        
			volume = -volume;
		mixerClose(hMixer);
		return (volume/SoundScale);
	}
	if (SetGetFLAG == 1) {  // caller wants to set sound value
	    // Initialize the MIXERCONTROLDETAILS structure
		ZeroMemory(&mxcd, sizeof(mxcd));    
		mxcd.cbStruct = sizeof(mxcd);
		mxcd.cbDetails = sizeof(volStruct);    
		mxcd.dwControlID = mxc.dwControlID;
		mxcd.paDetails = &volStruct;   
		mxcd.cChannels = 1;
		volStruct.lValue = (newvol*SoundScale);
		rc = mixerSetControlDetails((HMIXEROBJ)hMixer, &mxcd,
                                 MIXER_GETCONTROLDETAILSF_VALUE);

	}	
	
	mixerClose(hMixer);
	return 0;
	
}


/* unused bna++
// Plays a specified MIDI file by using MCI_OPEN and MCI_PLAY. Returns 
// as soon as playback begins. The window procedure function for the 
// specified window will be notified when playback is complete. 
// Returns 0L on success; otherwise, it returns an MCI error code.

DWORD playMIDIFile(HWND hWndNotify, LPSTR lpszMIDIFileName)
{
    UINT wDeviceID;
    DWORD dwReturn;
    MCI_OPEN_PARMS mciOpenParms;
    MCI_PLAY_PARMS mciPlayParms;
    MCI_STATUS_PARMS mciStatusParms;
    MCI_SEQ_SET_PARMS mciSeqSetParms;

    // Open the device by specifying the device and filename.
    // MCI will attempt to choose the MIDI mapper as the output port.
    mciOpenParms.lpstrDeviceType = "sequencer";
    mciOpenParms.lpstrElementName = lpszMIDIFileName;
    if (dwReturn = mciSendCommand(NULL, MCI_OPEN,
        MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,
        (DWORD)(LPVOID) &mciOpenParms))
    {
        // Failed to open device. Don't close it; just return error.
        return (dwReturn);
    }

    // The device opened successfully; get the device ID.
    wDeviceID = mciOpenParms.wDeviceID;

    // Check if the output port is the MIDI mapper.
    mciStatusParms.dwItem = MCI_SEQ_STATUS_PORT;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_STATUS, 
        MCI_STATUS_ITEM, (DWORD)(LPVOID) &mciStatusParms))
    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return (dwReturn);
    }

    // The output port is not the MIDI mapper. 
    // Ask if the user wants to continue.
    if (LOWORD(mciStatusParms.dwReturn) != MIDI_MAPPER)
    {
        if (MessageBox(hMainWnd,
            "The MIDI mapper is not available. Continue?",
            "", MB_YESNO) == IDNO)
        {
            // User does not want to continue. Not an error;
            // just close the device and return.
            mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
            return (0L);
        }
    }

    // Begin playback. The window procedure function for the parent 
    // window will be notified with an MM_MCINOTIFY message when 
    // playback is complete. At this time, the window procedure closes 
    // the device.
    mciPlayParms.dwCallback = (DWORD) hWndNotify;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_PLAY, MCI_NOTIFY, 
        (DWORD)(LPVOID) &mciPlayParms))
    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return (dwReturn);
    }

    return (0L);
}
*/ 

/* unused bna
// Plays a specified waveform-audio file using MCI_OPEN and MCI_PLAY. 
// Returns when playback begins. Returns 0L on success, otherwise 
// returns an MCI error code.
DWORD playWAVEFile(HWND hWndNotify, LPSTR lpszWAVEFileName)
{   
	UINT wDeviceID;
    DWORD dwReturn;    
	MCI_OPEN_PARMS mciOpenParms;
    MCI_PLAY_PARMS mciPlayParms;
    // Open the device by specifying the device and filename.
    // MCI will choose a device capable of playing the specified file.
    mciOpenParms.lpstrDeviceType = "waveaudio";
    mciOpenParms.lpstrElementName = lpszWAVEFileName;
    if (dwReturn = mciSendCommand(0, MCI_OPEN,
       MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,        
	   (DWORD)(LPVOID) &mciOpenParms))
    {        
		// Failed to open device. Don't close it; just return error.
        return (dwReturn);    
	}
    // The device opened successfully; get the device ID.
    wDeviceID = mciOpenParms.wDeviceID;
    // Begin playback. The window procedure function for the parent 
    // window will be notified with an MM_MCINOTIFY message when 
    // playback is complete. At this time, the window procedure closes 
    // the device.    mciPlayParms.dwCallback = (DWORD) hWndNotify;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_PLAY, MCI_NOTIFY, 
        (DWORD)(LPVOID) &mciPlayParms))    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);        
		return (dwReturn);
    }    
	return (0L);
}
*/

